;;; Sierra Script 1.0 - (do not remove this comment)
(script# 600)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	ortega 0
)

(local
	local0
)
(instance ortega of Rgn
	(properties)
	
	(method (init)
		(self keep: 0)
		(super init:)
		(Load rsVIEW 94)
		(Load rsVIEW 89)
		(Load rsSOUND 45)
		(Load rsSOUND 78)
	)
	
	(method (doit)
		(super doit:)
		(if global180
			(= global180 0)
			(gRoom setScript: FallDown)
		)
		(if (and global219 (> global171 1)) (-- global171))
		(if
			(and
				(== global171 1)
				(!= gCurRoomNum 62)
				(== (proc0_15 gEgo 15) 1)
				(== (gRoom script?) 0)
			)
			(gRoom setScript: FryToDeath)
		)
		(if (and global256 (not (-- global257)))
			(boom play:)
			(ShakeScreen 20 3)
			(= global257 (Random 10 600))
			(if (not global184) (Print 600 0) (= global184 1))
		)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(if
		(or (pEvent claimed?) (!= (pEvent type?) evSAID))
			(return)
		)
		(cond 
			((Said 'look>')
				(cond 
					((Said '[/area,around,moon,dirt,ortega]')
						(if (== gCurRoomNum 70)
							(if global253 (Print 600 1) else (Print 600 2))
						else
							(Print 600 3)
						)
					)
					((Said '/volcano') (Print 600 4))
					((Said '/lava') (Print 600 5))
					((Said '/rock,boulder') (Print 600 6))
					((Said '/lake') (Print 600 7))
					((Said '/air') (Print 600 8))
					((Said '/ledge,cliff,edge') (Print 600 9))
					((Said '/crack') (Print 600 10))
					((Said '/cavity,canyon') (Print 600 11))
					((Said '/partition')
						(if
							(or
								(== gCurRoomNum 73)
								(== gCurRoomNum 74)
								(== gCurRoomNum 75)
							)
							(Print 600 12)
						else
							(Print 600 13)
						)
					)
					((Said '/craft')
						(switch gCurRoomNum
							(62 (Print 600 14))
							(67 (Print 600 15))
							(70
								(if global253 (Print 600 16) else (Print 600 17))
							)
							(else  (Print 600 16))
						)
					)
				)
			)
			((Said 'open/door') (Print 600 18))
			((Said 'jump<off/cliff') (Print 600 19))
			((Said 'get/ladder')
				(if (or (== gCurRoomNum 74) (== gCurRoomNum 75))
					(Print 600 20)
				else
					(Print 600 21)
				)
			)
			((Said 'get/rock') (Print 600 22))
			((Said 'get/dirt') (Print 600 23))
			((Said 'use/pole') (if (!= gCurRoomNum 66) (PrintNotNow)))
			((Said '(turn<on),press,use/detonator')
				(if (gEgo has: 10)
					(Print 600 24)
				else
					(PrintDontHaveIt)
				)
			)
			((Said 'wear/panties')
				(if (gEgo has: 5)
					(if global182 (Print 600 25) else (Print 600 26))
				else
					(Print 600 27)
				)
			)
			((Said 'remove/panties') (if global182 (Print 600 28) else (Print 600 29)))
			((and (Said 'climb') (< gCurRoomNum 73)) (Print 600 30))
		)
	)
)

(instance FryToDeath of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(= global159 1)
				(= global171 0)
				(Print 600 31)
				(gEgo
					view: 89
					setLoop: 0
					setCel: 0
					setMotion: 0
					setCycle: End self
				)
			)
			(1
				(gEgo setLoop: 1 setCel: 0 setCycle: End self)
			)
			(2
				(gEgo setLoop: 2 setCel: 0 setCycle: End self)
			)
			(3 (= cycles 10))
			(4
				(Print 600 32)
				(proc0_17 0 0 8 11)
				(= global159 0)
				(HandsOn)
			)
		)
	)
)

(instance FallDown of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if (== (fallSound prevSignal?) -1) (= local0 1))
		(if (or local0 (== (fallSound state?) 0))
			(= local0 0)
			(self changeState: 1)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(fallSound play:)
				(gEgo setLoop: setCel: 0 setStep: 6 12 setCycle: 0)
				(AnimateCast)
				(gEgo setMotion: MoveTo (gEgo x?) 229)
				(ohnoScript changeState: 0)
			)
			(1 (proc0_17 0 0 1 2))
		)
	)
)

(instance ohnoScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ohno init: setCycle: End self)
			)
			(1 (ohno dispose:))
		)
	)
)

(instance ohno of Prop
	(properties)
	
	(method (init)
		(super init:)
		(self
			view: 94
			setLoop: 0
			setCel: 0
			cycleSpeed: 1
			setPri: (gEgo priority?)
			posn: (gEgo x?) (- (gEgo y?) 40)
			ignoreActors: 1
		)
	)
)

(instance fallSound of Sound
	(properties
		number 45
		priority 3
	)
)

(instance boom of Sound
	(properties
		number 78
		priority 1
	)
)
