;;; Sierra Script 1.0 - (do not remove this comment)
(script# 72)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Cycle)
(use Game)
(use Obj)

(public
	rm072 0
)

(instance rm072 of Rm
	(properties
		picture 72
		north 74
		south 71
	)
	
	(method (init &tmp [temp0 50])
		(HandsOn)
		(self setRegions: 600)
		(super init:)
		(switch gPrevRoomNum
			(71
				(gEgo
					init:
					posn:
						(cond 
							((< (gEgo x?) 67) 67)
							((< (gEgo x?) 193) 193)
							(else (gEgo x?))
						)
						187
				)
				(AnimateCast)
				(if global256
					(gLongSong number: 71 loop: -1 priority: 0 play:)
				else
					(gLongSong number: 51 loop: -1 priority: 0 play:)
				)
				(Print 72 0)
			)
			(74
				(gRoom setScript: EnterScript)
			)
		)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if
		(and (== (gEgo onControl:) 3) (not (gRoom script?)))
			(self setScript: LeaveScript)
		)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(if
		(or (!= (pEvent type?) evSAID) (pEvent claimed?))
			(return)
		)
		(cond 
			((Said 'look/device,building,generator')
				(cond 
					((not global256) (if global170 (Print 72 1) else (Print 72 2)))
					(global170 (Print 72 3))
					(else (Print 72 4))
				)
			)
			((Said 'look/beam')
				(if (not global256)
					(if global170 (Print 72 5) else (Print 72 6))
				else
					(Print 72 7)
				)
			)
			((Said 'look/butte') (Print 72 8))
		)
	)
)

(instance EnterScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					setPri: 3
					setLoop: 0
					illegalBits: 0
					posn: 217 156
					init:
					setMotion: MoveTo 241 132 self
				)
			)
			(1
				(gEgo setLoop: 2 setMotion: MoveTo 241 144 self)
			)
			(2
				(gEgo setLoop: -1 illegalBits: -32768 setPri: -1)
				(HandsOn)
				(gRoom setScript: 0)
			)
		)
	)
)

(instance LeaveScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					setPri: 3
					setLoop: 1
					illegalBits: 0
					setMotion: MoveTo 217 156 self
				)
			)
			(1
				(gEgo setLoop: -1)
				(HandsOn)
				(if global256 (++ global593))
				(gRoom newRoom: 74)
			)
		)
	)
)
