;;; Sierra Script 1.0 - (do not remove this comment)
(script# 25)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Cycle)
(use Game)
(use User)
(use Feature)
(use Obj)

(public
	rm25 0
)

(local
	local0
	local1
	local2
)
(instance rm25 of Rm
	(properties
		picture 25
	)
	
	(method (init &tmp [temp0 50])
		(User canInput: 1 canControl: 1)
		(Load rsVIEW 38)
		(eyes init: setScript: BoredEyes)
		(mouth init: setScript: BoredMouth)
		(super init:)
		(gAddToPics add: sine)
		(gAddToPics doit:)
		(Display 25 0 100 121 183 105 600 106 90 102 0)
		(switch gPrevRoomNum
			(29 (gRoom setScript: Welcome))
			(280
				(if (> global244 0) (gRoom setScript: PayUp))
			)
		)
	)
	
	(method (doit)
		(super doit:)
	)
	
	(method (handleEvent pEvent &tmp [temp0 50])
		(if (pEvent claimed?) (return))
		(switch (pEvent type?)
			(evSAID
				(cond 
					(
						(or
							(Said 'pay[/dinner,alien,man,clerk,him,bill]')
							(Said 'give/bill')
						)
						(cond 
							((or (!= gPrevRoomNum 280) (not global244)) (Print 25 1))
							((>= global154 global244)
								(if (not (= global154 (- global154 global244)))
									(gEgo put: 8 -1)
								)
								(= global247 1)
								(= global244 0)
								(= global248 1)
								(if global249 (gGame changeScore: 10))
								(= global193 0)
								(gRoom setScript: LeaveRoom)
							)
							(else (gRoom setScript: noMoney))
						)
					)
					((Said 'give,trade/crystal[/dinner]') (Print 25 2))
					((or (Said 'disembark[/area]') (Said '/bye'))
						(= global244 0)
						(= global248 0)
						(= global193 0)
						(= global101 0)
						(gRoom newRoom: 29)
					)
					((Said 'look[/area]') (Print 25 3))
					((Said 'look/up,down,deck,ceiling') (Print 25 4))
					((Said 'look,read/menace') (Print 25 5))
					((Said 'look/attire,cap') (Print 25 6))
					((Said '/bitch,her') (Print 25 7))
					(
					(Said 'look/man,clerk,alien,him,bystander,animal') (Print 25 8))
					((Said 'look/eye') (Print 25 9))
					((Said 'look/lip') (Print 25 10))
					((Said 'look/cavity') (Print 25 11))
					(
					(Said 'converse[/man,clerk,alien,him,bystander,animal]') (Print 25 12))
					(
					(Said 'kiss/man,clerk,alien,him,bystander,animal') (Print 25 13))
					(
					(Said 'smell[/man,clerk,alien,him,bystander,animal]') (Print 25 14))
					((Said 'consume') (Print 25 15))
					(
						(or
							(Said 'look,read/menu')
							(Said 'order')
							(Said 'order,buy/dinner')
							(Said 'converse/clerk')
						)
						(gRoom newRoom: 280)
					)
				)
			)
			(evKEYBOARD
				(if (== (pEvent message?) KEY_F6)
					(pEvent claimed: 1)
					(= global193 0)
					(= global101 0)
					(gRoom setScript: LeaveRoom)
				)
			)
			(evMOUSEBUTTON
				(if
					(and
						(<= 119 (pEvent x?))
						(<= (pEvent x?) 202)
						(<= 163 (pEvent y?))
						(<= (pEvent y?) 190)
					)
					(pEvent claimed: 1)
					(= global193 0)
					(= global101 0)
					(gRoom setScript: LeaveRoom)
				)
			)
		)
	)
)

(instance Welcome of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global193 1)
				(balloon init: setCel: 1 stopUpd:)
				(mouth setLoop: 0 setCycle: Fwd)
				(= seconds 4)
			)
			(1
				(balloon setCel: 2)
				(= seconds 4)
			)
			(2
				(mouth setCel: 0 stopUpd:)
				(balloon dispose:)
				(gRoom setScript: 0)
				(= global193 0)
			)
		)
	)
)

(instance noMoney of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global193 1)
				(if (== local0 1)
					(= local0 0)
					(eyes setMotion: MoveTo 155 74)
				)
				(balloon init: setCel: 4 stopUpd:)
				(mouth setLoop: 0 setCycle: Fwd)
				(= seconds 7)
			)
			(1
				(= global244 0)
				(= global247 0)
				(= global193 0)
				(= global101 0)
				(gRoom newRoom: 29)
			)
		)
	)
)

(instance LeaveRoom of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(balloon dispose:)
				(= cycles 1)
			)
			(1
				(Display 25 16 108 local1)
				(gRoom newRoom: 29)
			)
		)
	)
)

(instance PayUp of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= global193 1)
				(balloon init: setCel: 3 stopUpd:)
				(= local1
					(Display
						(Format @global402 25 17 global244)
						100
						207
						98
						106
						30
						102
						0
						103
						15
						105
						600
						107
					)
				)
				(mouth setLoop: 0 setCycle: Fwd)
				(= seconds 7)
			)
			(1
				(mouth setCel: 0 stopUpd:)
				(balloon dispose:)
				(= cycles 2)
			)
			(2
				(Display 25 16 108 local1)
				(= global193 0)
				(gRoom setScript: 0)
			)
		)
	)
)

(instance BoredMouth of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 5 15)))
			(1
				(if (!= (rm25 script?) 0)
					(self changeState: 0)
				else
					(mouth setLoop: 1 setCel: (Random 0 2))
				)
				(self changeState: 0)
			)
		)
	)
)

(instance BoredEyes of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 3 12)))
			(1
				(cond 
					((!= (rm25 script?) 0) (self changeState: 0))
					((== local0 0)
						(= local0 1)
						(switch (Random 1 3)
							(1
								(eyes setMotion: MoveTo 155 61 self)
							)
							(2
								(eyes setMotion: MoveTo 172 71 self)
							)
							(3
								(eyes setMotion: MoveTo 139 71 self)
							)
						)
					)
					(else (= local0 0) (eyes setMotion: MoveTo 155 71 self))
				)
			)
			(2 (self changeState: 0))
		)
	)
)

(instance eyes of Act
	(properties)
	
	(method (init)
		(super init:)
		(self view: 38 setLoop: 2 posn: 155 71 ignoreActors: 1)
	)
)

(instance mouth of Act
	(properties)
	
	(method (init)
		(super init:)
		(self
			view: 38
			setLoop: 1
			setCel: 0
			posn: 155 137
			ignoreActors: 1
			cycleSpeed: 2
		)
	)
)

(instance balloon of Prop
	(properties)
	
	(method (init)
		(super init:)
		(self
			view: 38
			setLoop: 3
			setCel: 3
			posn: 206 119
			setPri: 15
		)
	)
)

(instance sine of PV
	(properties
		y 89
		x 290
		view 38
		loop 3
		priority 15
		signal $4000
	)
)
