;;; Sierra Script 1.0 - (do not remove this comment)
(script# 997)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Sound)
(use User)


(class TheMenuBar of Class_255_0
	(properties
		state $0000
	)
	
	(method (init)
		(AddMenu { \01_} {About game`^a :Help`#1 :VaporCalc`^c_})
		(AddMenu
			{ File_}
			{Save Game`#5 :Restore Game`#7 :--! :Restart Game`#9 :Quit`^q_}
		)
		(AddMenu
			{ Action_}
			{Pause Game`^p :Inventory`^I :Retype`#3 :--! :Boss Key`^b_}
		)
		(AddMenu
			{ Speed_}
			{Change...`^s :--! :Faster`+ :Normal`= :Slower`-_}
		)
		(AddMenu { Sound_} {Volume...`^v :Sound Off`#2=1_})
		(SetMenu 513 109 'save')
		(SetMenu 514 109 'restore')
		(SetMenu 516 109 'restart')
		(SetMenu 517 109 'quit')
		(SetMenu 769 109 'pause')
		(SetMenu 770 109 'inventory')
		(SetMenu 1028 109 'normal')
		(SetMenu 1027 109 'faster')
		(SetMenu 1029 109 'slower')
		(SetMenu 258 109 'aid')
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1 [temp2 401])
		(switch (super handleEvent: pEvent (User blocks?))
			(257
				(Print
					(Format @temp2 997 0 gVersion)
					#font
					3
					#mode
					1
					#title
					{Space Quest \0B}
				)
			)
			(258 (Print 997 1 #font 3))
			(259
				(if (or (== gCurRoomNum 900) (== gCurRoomNum 1))
					(pEvent claimed: 0)
				else
					(= global251 1)
				)
			)
			(513
				(if global193 (Print 997 2) else (gGame save:))
			)
			(514 (gGame restore:))
			(516
				(if
					(Print
						997
						3
						#title
						{Restart}
						#icon
						602
						1
						0
						#font
						300
						#button
						{Restart}
						1
						#button
						{Oops}
						0
					)
					(gGame restart:)
				)
			)
			(517
				(if (!= gCurRoomNum 290)
					(= gQuit
						(Print
							997
							4
							#title
							{Bailing Out?}
							#icon
							602
							1
							0
							#font
							300
							#button
							{Quit}
							1
							#button
							{Oops}
							0
						)
					)
				else
					(pEvent claimed: 0)
				)
			)
			(769
				(= temp0 (Sound pause: 1))
				(Print
					997
					5
					#title
					{This game is paused.}
					#icon
					602
					1
					0
					#font
					300
					#button
					{Ok. I'm back.}
					1
				)
				(DoSound sndPAUSE temp0)
			)
			(770 (gInv showSelf: gEgo))
			(771
				(pEvent claimed: 0 type: 4 message: (User echo?))
			)
			(773
				(Print 997 6)
				(Print
					(Format
						@temp2
						{In fact, you don't want your boss to know that you've been playing Space Quest ]I[ for %d hours, %d minutes and %d seconds.}
						global228
						global227
						global226
					)
				)
				(Print 997 7)
			)
			(1025
				(if
				(!= (= temp1 (GetNumber {Speed (1 - 16)?} gSpeed)) -1)
					(if (< temp1 1) (= temp1 1))
					(if (> temp1 16) (= temp1 16))
					(gGame setSpeed: temp1)
				)
			)
			(1027
				(if (> gSpeed 1) (gGame setSpeed: (-- gSpeed)))
			)
			(1028 (gGame setSpeed: 5))
			(1029
				(if (< gSpeed 16) (gGame setSpeed: (++ gSpeed)))
			)
			(1281
				(if
					(!=
						(= temp1
							(GetNumber {Volume (1 - 16)?} (+ 1 (DoSound sndVOLUME)))
						)
						-1
					)
					(if (< (-- temp1) 0) (= temp1 0))
					(if (> temp1 15) (= temp1 15))
					(DoSound sndVOLUME temp1)
				)
			)
			(1282
				(if (GetMenu 1282 113)
					(DoSound sndSET_SOUND 0)
					(SetMenu 1282 113 0 110 {Turn on})
				else
					(DoSound sndSET_SOUND 1)
					(SetMenu 1282 113 1 110 {Turn off})
				)
			)
		)
	)
)
