;;; Sierra Script 1.0 - (do not remove this comment)
(script# 74)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Cycle)
(use Game)
(use User)
(use Obj)

(public
	rm074 0
)

(local
	local0
	local1
)
(instance rm074 of Rm
	(properties
		picture 74
		south 72
		west 73
	)
	
	(method (init &tmp [temp0 50])
		(User canInput: 1 canControl: 1)
		(self setRegions: 600)
		(Load rsVIEW 68)
		(Load rsVIEW 97)
		(super init:)
		(switch gPrevRoomNum
			(72
				(gEgo init: illegalBits: 16384 setPri: 14 posn: 225 187)
			)
			(73
				(if global255
					(gRoom setScript: UpStairs)
				else
					(gEgo posn: 2 (gEgo y?) init:)
				)
			)
			(75
				(if global256
					(gLongSong number: 71 loop: -1 priority: 0 play:)
				else
					(gLongSong number: 51 loop: -1 priority: 0 play:)
				)
				(gRoom setScript: DownLadder)
			)
		)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(if local0 (gRoom newRoom: 73))
		(if local1 (gRoom newRoom: 75))
		(if (== (gEgo view?) 68)
			(if (> (gEgo y?) 174)
				(gEgo setPri: 13)
			else
				(gEgo setPri: -1)
			)
		)
		(if
			(and
				(not (gRoom script?))
				(== (gEgo onControl:) 5)
				(!= (gEgo view?) 68)
			)
			(self setScript: DownStairs)
		)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(if
		(or (!= (pEvent type?) evSAID) (pEvent claimed?))
			(return)
		)
		(cond 
			((Said 'look>')
				(cond 
					((Said '[/area,around]')
						(if (== (gEgo view?) 0)
							(Print 74 0)
						else
							(Print 74 1)
						)
					)
					((Said '/lava') (Print 74 2))
					((Said '/ladder') (Print 74 3))
					((Said '/stair') (Print 74 4))
					((Said '/banister') (Print 74 5))
					((Said '/device,building,generator')
						(cond 
							((not global256) (if global170 (Print 74 6) else (Print 74 7)))
							(global170 (Print 74 8))
							(else (Print 74 9))
						)
					)
					((Said '/beam')
						(if (not global256)
							(if global170 (Print 74 10) else (Print 74 11))
						else
							(Print 74 12)
						)
					)
					((Said '/pedestal') (Print 74 13))
				)
			)
			((Said 'up,climb,(climb[<up])[/ladder]')
				(if (gEgo inRect: 146 108 163 112)
					(gRoom setScript: UpLadder)
				else
					(Print 74 14)
				)
			)
		)
	)
	
	(method (newRoom newRoomNumber)
		(if (not script)
			(if local0 (= global255 1) else (= global255 0))
			(if global256 (++ global593))
			(super newRoom: newRoomNumber)
		)
	)
)

(instance DownStairs of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					setLoop: 1
					illegalBits: 0
					setMotion: MoveTo 88 216 self
				)
			)
			(1
				(= local0 1)
				(HandsOn)
				(gRoom setScript: 0)
			)
		)
	)
)

(instance UpStairs of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					view: 0
					posn: 88 216
					setLoop: 0
					setPri: 14
					setStep: 3 2
					illegalBits: 0
					init:
				)
				(= cycles 2)
			)
			(1
				(gEgo setMotion: MoveTo 138 175 self)
			)
			(2
				(gEgo setLoop: -1 illegalBits: 16384)
				(HandsOn)
				(gRoom setScript: 0)
			)
		)
	)
)

(instance UpLadder of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo illegalBits: 0)
				(AnimateCast)
				(gEgo
					posn: 154 107
					view: 97
					setLoop: 0
					setMotion: MoveTo 154 65 self
				)
			)
			(1
				(gEgo posn: 153 65 setMotion: MoveTo 153 31 self)
			)
			(2
				(gEgo posn: 152 31 setMotion: MoveTo 152 13 self)
			)
			(3
				(gEgo posn: 151 13 setMotion: MoveTo 151 -2 self)
			)
			(4
				(HandsOn)
				(= local1 1)
				(gRoom setScript: 0)
			)
		)
	)
)

(instance DownLadder of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					init:
					posn: 151 -2
					view: 97
					illegalBits: 0
					setLoop: 0
					setMotion: MoveTo 151 13 self
				)
			)
			(1
				(gEgo posn: 152 13 setMotion: MoveTo 152 31 self)
			)
			(2
				(gEgo posn: 153 31 setMotion: MoveTo 153 65 self)
			)
			(3
				(gEgo posn: 154 65 setMotion: MoveTo 154 109 self)
			)
			(4
				(gEgo
					view: 68
					setLoop: -1
					setStep: 2 2
					illegalBits: -32768
				)
				(= cycles 2)
			)
			(5
				(gEgo loop: 3)
				(HandsOn)
				(gRoom setScript: 0)
			)
		)
	)
)
