;;; Sierra Script 1.0 - (do not remove this comment)
(script# 98)
(include sci.sh)
(use Main)
(use Timer)
(use Game)
(use Feature)
(use Obj)

(public
	rm98 0
)

(local
	local0
)
(instance rm98 of Rm
	(properties
		picture 121
		style $0005
	)
	
	(method (init)
		(HandsOff)
		(Load rsVIEW 54)
		(Load rsPIC 201)
		(Load rsPIC 202)
		(Load rsPIC 203)
		(Load rsPIC 204)
		(Load rsPIC 205)
		(Load rsPIC 206)
		(Load rsPIC 207)
		(Load rsSOUND 93)
		(spaceShip init:)
		(super init:)
		(self setScript: startShip)
	)
)

(instance startShip of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== (self state?) 3)
				(== (gLongSong prevSignal?) 10)
			)
			(self cue:)
		)
		(super doit:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= local0
					(Display
						{You enter a blackness like no other you\0Ahave ever experienced. All sense of time\0Aand speed are lost.}
						106
						250
						100
						35
						80
						101
						1
						105
						300
						102
						14
						107
					)
				)
				(Timer setReal: self 10)
			)
			(1
				(Display 98 0 108 local0)
				(= local0
					(Display
						{Suddenly...}
						106
						250
						100
						35
						95
						101
						1
						105
						300
						102
						14
						107
					)
				)
				(Timer setReal: self 3)
			)
			(2
				(Display 98 0 108 local0)
				(= local0
					(Display
						{A bright light becomes visible in the\0Adistance. It grows larger as your ship\0Araces toward it. Finally you are hurled\0Aout of the blackness into a parallel universe.}
						106
						250
						100
						35
						70
						101
						1
						105
						300
						102
						14
						107
					)
				)
				(Timer setReal: self 10)
			)
			(3)
			(4
				(Display 98 0 108 local0)
				(spaceShip show:)
				(gRoom overlay: 201 5)
				(Timer setCycle: self 1)
			)
			(5
				(gRoom overlay: 202 5)
				(Timer setCycle: self 1)
			)
			(6
				(gRoom overlay: 203 5)
				(Timer setCycle: self 1)
			)
			(7
				(gRoom overlay: 204 5)
				(Timer setCycle: self 1)
			)
			(8
				(gRoom overlay: 205 5)
				(Timer setCycle: self 1)
			)
			(9
				(gRoom overlay: 206 5)
				(Timer setCycle: self 1)
			)
			(10
				(gRoom overlay: 207 5)
				(Timer setCycle: self 1)
			)
			(11
				(if (< (spaceShip cel?) (spaceShip lastCel:))
					(spaceShip
						setCel: (+ (spaceShip cel?) 1)
						posn: (spaceShip x?) (- (spaceShip y?) 2)
					)
					(-- state)
					(Timer setCycle: self 1)
				else
					(self cue:)
				)
			)
			(12
				(spaceShip hide:)
				(Timer setReal: self 2)
			)
			(13 (gRoom newRoom: 115))
		)
	)
)

(instance spaceShip of Prop
	(properties
		view 54
		priority 15
	)
	
	(method (init)
		(super init:)
		(self posn: 154 100 hide:)
	)
)
